<script lang="ts">
import Vue from 'vue';
import { UseLiteVimeo, UseLocalizedVideoSubtitles } from '~/mixins';
import VideoModal from '~/components/solutions/video-modal.vue';

export default Vue.extend({
  name: 'DibPillar1Talent',
  components: {
    VideoModal,
  },
  mixins: [UseLiteVimeo, UseLocalizedVideoSubtitles],
  props: {
    data: {
      type: Object,
      required: true,
    },
  },
  data() {
    return {
      modal: {
        open: false,
      },
    };
  },
  methods: {
    openVideoModal() {
      this.modal.open = true;
      // Make sure Vimeo analytics work:
      // https://vimeo.zendesk.com/hc/en-us/articles/115002859607-Integrate-the-Vimeo-player-with-Google-Tag-Manager
      setTimeout(() => {
        window.__vimeoRefresh();
      }, 3000);
    },
    closeModal() {
      this.modal.open = false;
    },
  },
});
</script>

<template>
  <SlpContainer>
    <SlpTypography variant="heading1-bold" tag="h2" class="slp-mb-64">
      {{ data.header }}
    </SlpTypography>
    <div class="header-content">
      <SlpTypography variant="heading2-bold" tag="h3" class="slp-mb-16">
        {{ data.subtitle }}
      </SlpTypography>
      <SlpTypography variant="heading5" tag="div" class="slp-mb-64">
        <div v-html="$md.render(data.text)" />
      </SlpTypography>
    </div>

    <SlpRow class="purple-cards-container">
      <SlpColumn
        v-for="card in data.purple_cards"
        :key="card.header"
        :cols="4"
        class="card-container"
      >
        <a
          :href="card.cta.href"
          :data-ga-name="card.cta.data_ga_name"
          :data-ga-location="card.cta.data_ga_location"
          class="card"
        >
          <SlpTypography variant="heading5-bold" tag="h3" class="slp-mb-24">
            {{ card.header }}
          </SlpTypography>
          <SlpTypography variant="body1" tag="div" class="slp-mb-24">
            <div class="card__text" v-html="$md.render(card.text)" />
          </SlpTypography>

          <div class="card-cta">
            <span>{{ card.cta.text }}</span>
            <SlpIcon
              class="learn-more-icon"
              name="chevron-lg-right"
              variant="product"
            />
          </div>
        </a>
      </SlpColumn>
    </SlpRow>
    <SlpRow class="white-cards-container">
      <div :cols="6" class="white-card-flex">
        <SlpRow class="content">
          <SlpColumn :cols="6" class="slp-pr-32">
            <SlpTypography variant="heading5-bold" tag="h3" class="slp-mb-24">
              {{ data.white_cards[0].header }}
            </SlpTypography>
            <SlpTypography variant="body1" tag="div" class="slp-mb-64">
              <div
                class="card__text"
                v-html="$md.render(data.white_cards[0].text)"
              />
            </SlpTypography>
            <SlpButton
              variant="tertiary"
              :href="data.white_cards[0].main_cta.href"
              :data-ga-name="data.white_cards[0].main_cta.data_ga_name"
              :data-ga-location="data.white_cards[0].main_cta.data_ga_location"
            >
              {{ data.white_cards[0].main_cta.text }}
              <SlpIcon
                class="learn-more-icon"
                name="chevron-lg-right"
                variant="product"
              />
            </SlpButton>
          </SlpColumn>
          <SlpColumn :cols="6" class="card__img-col" size="md">
            <div
              v-if="data.white_cards[0].video"
              class="video-wrapper"
              @click="openVideoModal()"
            >
              <SlpIcon
                class="play-icon"
                name="play-circle"
                variant="marketing"
                size="lg"
              />
              <img
                id="video-container__image"
                preload
                class="thumbnail-image"
                :src="data.white_cards[0].video.thumbnail"
                alt=""
              />
            </div>

            <VideoModal
              v-if="data.white_cards[0].video"
              v-show="modal.open && data.white_cards[0].video"
              light-background
              :visible="modal.open"
              @closeModal="modal.open = false"
            >
              <template #body>
                <lite-vimeo
                  :videoid="
                    getVimeoVideoId(
                      createVideoSource(data.white_cards[0].video.video_src),
                    )
                  "
                  :videotitle="
                    getVimeoVideoId(data.white_cards[0].video.video_src)
                  "
                  autoplay
                ></lite-vimeo>
              </template>
            </VideoModal>
          </SlpColumn>
          <div class="link-list slp-mt-64">
            <SlpButton
              v-for="link in data.white_cards[0].cta_list"
              :key="link.text"
              variant="tertiary"
              :href="link.href"
              :data-ga-name="link.data_ga_name"
              :data-ga-location="link.data_ga_location"
            >
              {{ link.text }}
              <SlpIcon variant="product" name="arrow-right" />
            </SlpButton>
          </div>
        </SlpRow>
      </div>

      <div class="solo-card-container">
        <div class="solo-card">
          <SlpTypography variant="heading5-bold" tag="h3" class="slp-mb-24">
            {{ data.white_cards[1].header }}
          </SlpTypography>
          <div class="solo-card__flex">
            <SlpTypography
              variant="body1"
              tag="div"
              class="card__text-container"
            >
              <div
                class="card__text"
                v-html="$md.render(data.white_cards[1].text)"
              />
            </SlpTypography>
            <div class="card__link-container">
              <div
                v-for="link in data.white_cards[1].cta_list"
                :key="link.text"
              >
                <SlpButton
                  v-if="link.href"
                  variant="tertiary"
                  :href="link.href"
                  :data-ga-name="link.data_ga_name"
                  :data-ga-location="link.data_ga_location"
                >
                  {{ link.text }}
                  <SlpIcon variant="product" name="arrow-right" />
                </SlpButton>
                <div v-else class="slp-mt-16">
                  <span class="bold">{{ link.text }}</span>
                  <span>(Coming soon)</span>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </SlpRow>
  </SlpContainer>
</template>

<style lang="scss" scoped>
.header-content {
  h3 {
    display: block;
    max-width: 80%;
  }

  .slp-text-heading5 {
    display: block;
    max-width: 60%;
  }

  @media (max-width: $breakpoint-md) {
    h3,
    .slp-text-heading5 {
      max-width: 100%;
    }
  }
}
.white-cards-container {
  padding: 16px;
  align-items: stretch;
}
.white-card-flex,
.solo-card {
  display: flex;
  padding: 24px 16px 24px 24px;
  justify-content: space-between;
  gap: 64px;
  border: 1px solid;
  border-radius: 8px;
  background: $color-surface-50;
  background-clip: padding-box;
  border: 1px solid transparent;
  position: relative;
  box-sizing: border-box;

  @media (max-width: $breakpoint-md) {
    flex-wrap: wrap;
  }

  &:before {
    content: '';
    position: absolute;
    top: 0;
    right: 0;
    bottom: 0;
    left: 0;
    z-index: -1;
    margin: -1px;
    border-radius: inherit;
    background: linear-gradient(
      93.78deg,
      rgba(227, 153, 93, 0.5) 8.53%,
      rgba(203, 146, 150, 0.5) 14.9%,
      rgba(127, 72, 214, 0.5) 95.91%
    );
  }

  .content {
    flex: 1 0 40%;

    @media (max-width: $breakpoint-md) {
      flex: 1 1 100%;
    }

    .card__img-col {
      display: flex;
      justify-content: right;
      position: relative;

      @media (max-width: $breakpoint-lg) {
        flex: 0 1 100%;
      }
    }
    &__img {
      position: relative;
      z-index: 1;
      margin-top: $spacing-48;
      width: 100%;
      max-height: 590px;
      object-fit: contain;
      @media (min-width: $breakpoint-md) {
        margin-top: 0;
      }
      @media (min-width: $breakpoint-lg) {
        width: auto;
      }
    }
  }

  .card__text {
    color: $color-text-200;
  }
  .link-list {
    display: flex;
    flex-wrap: wrap;
    justify-content: space-between;
    a {
      width: 30%;
      text-align: left;
      justify-content: space-between;

      @media (max-width: $breakpoint-md) {
        width: 100%;
      }
    }
  }

  .bold {
    font-weight: $font-weight-bold;
    font-size: 18px;
    line-height: 20px;
  }
}

.white-cards-container {
  margin-top: 24px;
}

.solo-card-container {
  margin-top: 60px;
  padding-left: 0;
}

.solo-card {
  height: 100%;
  flex-direction: column;
  gap: 0;

  a {
    width: 100%;
    justify-content: space-between;
  }

  &__flex {
    display: flex;
    flex-direction: row;

    .card__text-container {
      width: 65%;
      padding: 11px 60px 0 0;
    }

    .card__link-container {
      width: 35%;
    }

    @media (max-width: $breakpoint-md) {
      flex-wrap: wrap;

      .card__text-container,
      .card__link-container {
        width: 100%;
      }
    }
  }
}

.video-wrapper {
  cursor: pointer;
  position: relative;
  flex: 1 1 100%;
  max-height: 456px;
  max-width: 594px;
  width: 35vw;
  border-radius: 8px 8px 160px 8px;
  display: flex;
  align-items: center;

  @media (max-width: $breakpoint-md) {
    margin: 24px 0 0 0;
    width: 100%;
    max-width: 100%;
    border-radius: 4px 4px 40px 4px;
  }

  .play-icon {
    color: $color-text-link-100;
    cursor: pointer;
    font-size: 48px;
    left: 50%;
    position: absolute;
    top: 50%;
    transform: translate(-50%, -50%);
    z-index: 2;
  }

  img {
    object-fit: cover;
    width: 100%;
    display: block;
    border-radius: 4px 4px 100px 4px;
    border: 1px solid $color-surface-300;
    @media (max-width: $breakpoint-md) {
      border-radius: 4px 4px 40px 4px;
    }
  }
}

.purple-cards-container {
  margin-top: 32px;
  margin-bottom: 16px;
  align-items: stretch;

  .card-container {
    padding: 16px;
    display: flex;
    flex-direction: column;
    flex-grow: 1;

    @media (max-width: breakpoint-md) {
      padding: 0;
    }
  }

  .card {
    border-radius: 8px;
    background: #f6f3fe;
    padding: 32px 24px;
    display: flex;
    flex-direction: column;
    flex-grow: 1;
    color: $color-text-300;
    transition: all 0.2s ease-in-out;

    .slp-icon {
      transition: all 0.2s ease-in-out;
    }

    &:hover {
      border-radius: 8px 8px 100px 8px;

      .slp-icon {
        transform: translateX(8px);
      }

      .card-cta {
        text-decoration-color: $color-text-300;

        transition: all 0.2s ease-in-out;
      }
    }

    &__text {
      color: $color-text-200;

      &:deep ul {
        list-style: disc;
        padding-left: 1.5em;
      }

      &:deep a {
        color: $color-text-200;
        text-decoration: underline;
      }
    }
  }
  .card-cta {
    box-sizing: border-box;
    font-family: 'GitLab Sans' 'sans-serif';
    min-width: 68px;
    display: inline-flex;
    align-items: center;
    text-align: center;
    vertical-align: middle;
    padding: 11px 16px;
    -webkit-text-decoration: none;
    text-decoration: underline;
    text-underline-offset: 4px;
    text-decoration-color: transparent;
    border-radius: 4px;
    font-weight: 600;
    font-size: 18px;
    line-height: 20px;
    color: #171321;
    border: none;
    padding-left: 0;
    transition: all 0.2s ease-in-out;
    margin-top: auto;
  }

  .cta-link {
    display: flex;
    align-items: center;
    text-decoration: none;
    color: inherit;
  }
}
</style>
